HDU 1535 && POJ 1511 Invitation Cards (SPFA 模板 + 反向建图)

Invitation Cards

HDU: Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)

POJ: Time Limit: 8000 MS     Memory Limit: 262144 K

     

Problem Description

In the age of television, not many people attend theater performances. Antique Comedians of Malidinesia are aware of this fact. They want to propagate theater and, most of all, Antique Comedies. They have
printed invitation cards with all the necessary information and with the programme. A lot of students were hired to distribute these invitations among the people. Each student volunteer has assigned exactly one bus stop and he or she stays there the whole
day and gives invitation to people travelling by bus. A special course was taken where students learned how to influence people and what is the difference between influencing and robbery.

The transport system is very special: all lines are unidirectional and connect exactly two stops. Buses leave the originating stop with passangers each half an hour. After reaching the destination stop they return empty to the originating stop, where they wait
until the next full half an hour, e.g. X:00 or X:30, where ‘X‘ denotes the hour. The fee for transport between two stops is given by special tables and is payable on the spot. The lines are planned in such a way, that each round trip (i.e. a journey starting
and finishing at the same stop) passes through a Central Checkpoint Stop (CCS) where each passenger has to pass a thorough check including body scan.

All the ACM student members leave the CCS each morning. Each volunteer is to move to one predetermined stop to invite passengers. There are as many volunteers as stops. At the end of the day, all students travel back to CCS. You are to write a computer program
that helps ACM to minimize the amount of money to pay every day for the transport of their employees.

Input

The input consists of N cases. The first line of the input contains only positive integer N. Then follow the cases. Each case begins with a line containing exactly two integers P and Q, 1 <= P,Q <= 1000000.
P is the number of stops including CCS and Q the number of bus lines. Then there are Q lines, each describing one bus line. Each of the lines contains exactly three numbers - the originating stop, the destination stop and the price. The CCS is designated by
number 1. Prices are positive integers the sum of which is smaller than 1000000000. You can also assume it is always possible to get from any stop to any other stop.

Output

For each case, print one line containing the minimum amount of money to be paid each day by ACM for the travel costs of its volunteers.

Sample Input

2
2 2
1 2 13
2 1 33
4 6
1 2 10
2 1 60
1 3 20
3 4 10
2 4 5
4 1 50

Sample Output

46
210

Source

Central Europe 1998

题目链接:POJ:http://poj.org/problem?id=1511

HDU:http://acm.hdu.edu.cn/showproblem.php?pid=1535

题目大意:一张有向图,求从点1开始到其他各点的最短路权值和加上从其他各点到点1的最短路权值和

题目分析:这题HDU的数据比较水,给的时间也短,POJ的数据超int,wa了几发,做法就是1到各点直接spfa搞一下,反过来,就把图也反过来建一下,再搞一次spfa就可以了,一套好板子也是很重要的,书上板子动态分配伤不起,其实vector也挺费时,在poj跑了4000ms+,但是比较好写

POJ:

#include <cstdio>
#include <cstring>
#include <vector>
#include <queue>
#define ll long long
int const MAX = 1e6 + 5;
ll const INF = 0xffffffff;
using namespace std;
struct NODE
{
    int v, w;
    NODE(int vv, ll ww)
    {
        v = vv;
        w = ww;
    }
};

struct EDGE
{
    int u, v;
    ll w;
}e[MAX];

vector <NODE> vt[MAX];
int p, q;
ll ans, dist[MAX];
bool vis[MAX];

void SPFA(int v0)
{
    memset(vis, false, sizeof(vis));
    for(int i = 0; i <= p; i++)
        dist[i] = INF;
    dist[v0] = 0;
    queue <int> Q;
    Q.push(v0);
    while(!Q.empty())
    {
        int u = Q.front();
        Q.pop();
        vis[u] = false;
        int sz = vt[u].size();
        for(int i = 0; i < sz; i++)
        {
            int v = vt[u][i].v;
            ll w = vt[u][i].w;
            if(dist[v] > dist[u] + w)
            {
                dist[v] = dist[u] + w;
                if(!vis[v])
                {
                    Q.push(v);
                    vis[v] = true;
                }
            }
        }
    }
}

void Clear()
{
    for(int i = 1; i <= p; i++)
        vt[i].clear();
}

int main()
{
    int T;
    scanf("%d", &T);
    while(T--)
    {
        ans = 0;
        scanf("%d %d", &p, &q);
        for(int i = 0; i < q; i++)
            scanf("%d %d %lld", &e[i].u, &e[i].v, &e[i].w);
        Clear();
        for(int i = 0; i < q; i++)
            vt[e[i].u].push_back(NODE(e[i].v, e[i].w));
        SPFA(1);
        for(int i = 1; i <= p; i++)
            ans += dist[i];
        Clear();
        for(int i = 0; i < q; i++)
            vt[e[i].v].push_back(NODE(e[i].u, e[i].w));
        SPFA(1);
        for(int i = 1; i <= p; i++)
            ans += dist[i];
        printf("%lld\n", ans);
    }
}

HDU:

#include <cstdio>
#include <cstring>
#include <vector>
#include <queue>
int const MAX = 1e6 + 5;
int const INF = 0xfffffff;
using namespace std;
struct NODE
{
    int v, w;
    NODE(int vv, int ww)
    {
        v = vv;
        w = ww;
    }
};

struct EDGE
{
    int u, v, w;
}e[MAX];

vector <NODE> vt[MAX];
int p, q, ans, dist[MAX];
bool vis[MAX];

void SPFA(int v0)
{
    memset(vis, false, sizeof(vis));
    for(int i = 0; i <= p; i++)
        dist[i] = INF;
    dist[v0] = 0;
    queue <int> Q;
    Q.push(v0);
    while(!Q.empty())
    {
        int u = Q.front();
        Q.pop();
        vis[u] = false;
        int sz = vt[u].size();
        for(int i = 0; i < sz; i++)
        {
            int v = vt[u][i].v;
            int w = vt[u][i].w;
            if(dist[v] > dist[u] + w)
            {
                dist[v] = dist[u] + w;
                if(!vis[v])
                {
                    Q.push(v);
                    vis[v] = true;
                }
            }
        }
    }
}

void Clear()
{
    for(int i = 1; i <= p; i++)
        vt[i].clear();
}

int main()
{
    int T;
    scanf("%d", &T);
    while(T--)
    {
        ans = 0;
        scanf("%d %d", &p, &q);
        for(int i = 0; i < q; i++)
            scanf("%d %d %d", &e[i].u, &e[i].v, &e[i].w);
        Clear();
        for(int i = 0; i < q; i++)
            vt[e[i].u].push_back(NODE(e[i].v, e[i].w));
        SPFA(1);
        for(int i = 1; i <= p; i++)
            ans += dist[i];
        Clear();
        for(int i = 0; i < q; i++)
            vt[e[i].v].push_back(NODE(e[i].u, e[i].w));
        SPFA(1);
        for(int i = 1; i <= p; i++)
            ans += dist[i];
        printf("%d\n", ans);
    }
}
时间: 2024-10-23 19:49:33

HDU 1535 && POJ 1511 Invitation Cards (SPFA 模板 + 反向建图)的相关文章

HDU 2680 Choose the best route &lt;SPFA算法+反向建图&gt;

Choose the best route Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 10690    Accepted Submission(s): 3454 Problem Description One day , Kiki wants to visit one of her friends. As she is liabl

poj 1511 Invitation Cards spfa 邻接矩阵

题目链接: http://poj.org/problem?id=1511 题目大意: 这道题目比较难理解,我读了好长时间,最后还是在队友的帮助下理解了题意,大意就是,以一为起点,求从一到其他各点的最短回路总和. 解题思路: 解决这个题目有几个容易错的,解决了离ac就不远了^_^. 1:数据范围是1<=边数<=顶点数<=1000000,所以不能用邻接矩阵,要用邻接表,用vector实现时要动态申请内存. 2:求得是起始点到其他点的最短回路和,我们可以建两个邻接表(一个正向,一个负向邻接表)

POJ 1511 Invitation Cards (最短路)

Invitation Cards Time Limit: 8000MS   Memory Limit: 262144K Total Submissions: 19215   Accepted: 6311 Description In the age of television, not many people attend theater performances. Antique Comedians of Malidinesia are aware of this fact. They wan

POJ 1511 Invitation Cards

题目来源:http://poj.org/problem?id=1511 题目很长,花了不少时间才理解题意,目的就是为了求出来回两次最小路径(即为本题的差旅费)之和, 第一次从CCS(1)出发到各个点路径最小,SPFA算法没得说,回来时终点是确定的都是CCS(1),相当于把路 径反过来,即把有向图去反方向,又是从1出发到各个点路径最小,再用一个SPFA.注意ans要用long long 不然也WA,这个地方WA了好几次,虽然更改后AC了,但还是不明白,题目明明写了smaller than 1000

[2016-04-05][POJ][1511][Invitation Cards]

时间:2016-04-05 12:57:22 星期二 题目编号:[2016-04-05][POJ][1511][Invitation Cards] 题目大意:给定一个有向图,从点1出发,分别到各个站点后,又回到点1,问最少需要多少车费, 分析: 从1跑一次最短路,然后矩阵转置,再跑一次最短路,两次求和 这里不能用邻接矩阵保存,所以改成邻接表,然后矩阵转置的操作变成重新加一次边 遇到的问题:用vector存图超时,改用数组实现 #include <queue> #include <algo

POJ 1511 Invitation Cards 【最短路,spfa算法,Dijkstra算法堆优化】

Invitation Cards Time Limit: 8000MS   Memory Limit: 262144K Total Submissions: 25219   Accepted: 8346 Description In the age of television, not many people attend theater performances. Antique Comedians of Malidinesia are aware of this fact. They wan

(简单) POJ 1511 Invitation Cards,SPFA。

Description In the age of television, not many people attend theater performances. Antique Comedians of Malidinesia are aware of this fact. They want to propagate theater and, most of all, Antique Comedies. They have printed invitation cards with all

poj 1511 Invitation Cards (spfa+邻接表)

Invitation Cards Time Limit: 8000MS   Memory Limit: 262144K Total Submissions: 19527   Accepted: 6375 Description In the age of television, not many people attend theater performances. Antique Comedians of Malidinesia are aware of this fact. They wan

POJ 1511 Invitation Cards(逆向思维 SPFA)

Description In the age of television, not many people attend theater performances. Antique Comedians of Malidinesia are aware of this fact. They want to propagate theater and, most of all, Antique Comedies. They have printed invitation cards with all